<?php

namespace IdelibreApiPhp\Tests\Api;

use IdelibreApiPhp\Api\SerializerHelper\DenormalizerHelper;
use IdelibreApiPhp\Api\v2\Check;
use IdelibreApiPhp\Client;
use IdelibreApiPhp\Enum\ApiPath;
use IdelibreApiPhp\Model\Api\UserApi;
use IdelibreApiPhp\Tests\Mocker\ClientMock;
use PHPUnit\Framework\MockObject\Exception;
use PHPUnit\Framework\TestCase;
use Psr\Http\Client\ClientExceptionInterface;
use Symfony\Component\PropertyInfo\Extractor\ReflectionExtractor;
use Symfony\Component\Serializer\Encoder\JsonEncoder;
use Symfony\Component\Serializer\Normalizer\ArrayDenormalizer;
use Symfony\Component\Serializer\Normalizer\DateTimeNormalizer;
use Symfony\Component\Serializer\Normalizer\GetSetMethodNormalizer;
use Symfony\Component\Serializer\Normalizer\ObjectNormalizer;
use Symfony\Component\Serializer\Serializer;

class CheckTest extends TestCase
{


    protected function setUp(): void
    {
        parent::setUp(); // TODO: Change the autogenerated stub
        $this->clientMock = new ClientMock(Client::class);
        $this->apiUser = $this->clientMock->isApiUser();
        $objectNormalizer = new ObjectNormalizer(null, null, null, new ReflectionExtractor());
        $getSetNormalizer = new GetSetMethodNormalizer();
        $dateTimeZoneNormalizer = new DateTimeNormalizer([DateTimeNormalizer::TIMEZONE_KEY => 'UTC']);
        $this->serializer = new Serializer([$objectNormalizer, $getSetNormalizer, new ArrayDenormalizer(),$dateTimeZoneNormalizer], [new JsonEncoder()]);
        $this->denormalizerHelper = new DenormalizerHelper();
    }


    /**
     * @throws Exception
     * @throws \Http\Client\Exception
     * @throws ClientExceptionInterface
     */
    public function testPing()
    {
        $response = '{"message": "success"}';

        $clientMock = $this->clientMock->mockClient('get', ApiPath::CHECK_ENDPOINT . '/ping', $response);

        $check = new Check($clientMock);
        $result = $check->ping();

        $this->assertEquals($response, $result);
    }

    /**
     * @throws Exception
     * @throws ClientExceptionInterface
     */
    public function testMe()
    {
        $apiResponse = '{"name":"apiuserLibriciel","structure":{"name":"Libriciel","id":"24c5f75b-9700-4e97-94a3-7038b7f145e9"},"role":{"name":"admin","id":"f1b1b1b1-1b1b-1b1b-1b1b-1b1b1b1b1b1b"}}';

        $clientMock = $this->clientMock->mockClient('get', ApiPath::CHECK_ENDPOINT . '/me', $apiResponse);

        $expected = $this->serializer->deserialize($apiResponse, UserApi::class, 'json');

        $check = new Check($clientMock);
        $me = $check->me();



        $this->assertEquals($expected, $me);
    }
}
